package tech.nevets.vplus.armor;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1304;
import net.minecraft.class_1741;
import net.minecraft.class_1802;
import net.minecraft.class_1856;
import net.minecraft.class_1935;
import net.minecraft.class_3414;
import net.minecraft.class_3417;
import net.minecraft.class_3528;
import tech.nevets.vplus.items.VPItems;

import java.util.function.Supplier;

public enum ArmorMaterials implements class_1741 {
    COPPER("copper", 13, new int[]{2, 4, 5, 2}, 20, class_3417.field_14862, 0.0F, 0.0F, () -> {
        return class_1856.method_8091(new class_1935[]{class_1802.field_27022});
    }),
    EMERALD("emerald", 30, new int[]{2, 6, 8, 2}, 30, class_3417.field_15103, 1.0F, 0.0F, () -> {
        return class_1856.method_8091(new class_1935[]{class_1802.field_8687});
    }),
    PLATINUM("platinum", 40, new int[]{6, 8, 10, 6}, 40, class_3417.field_15103, 1.0F, 0.5F, () -> {
        return class_1856.method_8091(new class_1935[]{VPItems.PLATINUMINGOT});
    }),
    RUBY("ruby", 75, new int[]{10, 15, 20, 10}, 100, class_3417.field_15103, 4.0F, 1.0F, () -> {
        return class_1856.method_8091(new class_1935[]{VPItems.RUBY});
    });

    private static final int[] BASE_DURABILITY = new int[]{13, 15, 16, 11};
    private final String name;
    private final int durabilityMultiplier;
    private final int[] protectionAmounts;
    private final int enchantability;
    private final class_3414 equipSound;
    private final float toughness;
    private final float knockbackResistance;
    private final class_3528<class_1856> repairIngredientSupplier;

    private ArmorMaterials(String name, int durabilityMultiplier, int[] protectionAmounts, int enchantability, class_3414 equipSound, float toughness, float knockbackResistance, Supplier<class_1856> repairIngredientSupplier) {
        this.name = name;
        this.durabilityMultiplier = durabilityMultiplier;
        this.protectionAmounts = protectionAmounts;
        this.enchantability = enchantability;
        this.equipSound = equipSound;
        this.toughness = toughness;
        this.knockbackResistance = knockbackResistance;
        this.repairIngredientSupplier = new class_3528(repairIngredientSupplier);
    }

    public int method_7696(class_1304 slot) {
        return BASE_DURABILITY[slot.method_5927()] * this.durabilityMultiplier;
    }

    public int method_7697(class_1304 slot) {
        return this.protectionAmounts[slot.method_5927()];
    }

    public int method_7699() {
        return this.enchantability;
    }

    public class_3414 method_7698() {
        return this.equipSound;
    }

    public class_1856 method_7695() {
        return (class_1856)this.repairIngredientSupplier.method_15332();
    }

    @Environment(EnvType.CLIENT)
    public String method_7694() {
        return this.name;
    }

    public float method_7700() {
        return this.toughness;
    }

    public float method_24355() {
        return this.knockbackResistance;
    }
}