package tech.nevets.vplus.init;

import static tech.nevets.vplus.misc.VPZoom.*;

public class ZoomInit {
    public static Boolean isZooming() {
        return keyBinding.method_1434();
    }

    public static void manageSmoothCamera() {
        if (zoomStarting()) {
            zoomStarted();
            enableSmoothCamera();
        }

        if (zoomStopping()) {
            zoomStopped();
            resetSmoothCamera();
        }
    }

    private static Boolean isSmoothCamera() {
        return mc.field_1690.field_1914;
    }

    private static void enableSmoothCamera() {
        mc.field_1690.field_1914 = true;
    }

    private static void disableSmoothCamera() {
        mc.field_1690.field_1914 = false;
    }

    private static boolean zoomStarting() {
        return isZooming() && !currentlyZoomed;
    }

    private static boolean zoomStopping() {
        return !isZooming() && currentlyZoomed;
    }

    private static void zoomStarted() {
        originalSmoothCameraEnabled = isSmoothCamera();
        currentlyZoomed = true;
    }

    private static void zoomStopped() {
        currentlyZoomed = false;
    }

    private static void resetSmoothCamera() {
        if (originalSmoothCameraEnabled) {
            enableSmoothCamera();
        } else {
            disableSmoothCamera();
        }
    }
}